// Generated by BUCKLESCRIPT VERSION 1.4.3, PLEASE EDIT WITH CARE
'use strict';

var Sys                      = require("bs-platform/lib/js/sys");
var Curry                    = require("bs-platform/lib/js/curry");
var Pervasives               = require("bs-platform/lib/js/pervasives");
var Web_Tar__Webgl           = require("./web_Tar__Webgl");
var Reglinterface__Constants = require("../reglinterface/reglinterface__Constants");

function getProgram(context, vertexShaderSource, fragmentShaderSource) {
  var vertexShader = Curry._2(Web_Tar__Webgl.Gl[/* createShader */7], context, Reglinterface__Constants.vertex_shader);
  Curry._3(Web_Tar__Webgl.Gl[/* shaderSource */10], context, vertexShader, vertexShaderSource);
  Curry._2(Web_Tar__Webgl.Gl[/* compileShader */11], context, vertexShader);
  var compiledCorrectly = +(Curry._3(Web_Tar__Webgl.Gl[/* getShaderParameter */47], context, vertexShader, /* Compile_status */1) === 1);
  if (compiledCorrectly) {
    var fragmentShader = Curry._2(Web_Tar__Webgl.Gl[/* createShader */7], context, Reglinterface__Constants.fragment_shader);
    Curry._3(Web_Tar__Webgl.Gl[/* shaderSource */10], context, fragmentShader, fragmentShaderSource);
    Curry._2(Web_Tar__Webgl.Gl[/* compileShader */11], context, fragmentShader);
    var compiledCorrectly$1 = +(Curry._3(Web_Tar__Webgl.Gl[/* getShaderParameter */47], context, fragmentShader, /* Compile_status */1) === 1);
    if (compiledCorrectly$1) {
      var program = Curry._1(Web_Tar__Webgl.Gl[/* createProgram */6], context);
      Curry._3(Web_Tar__Webgl.Gl[/* attachShader */8], context, program, vertexShader);
      Curry._2(Web_Tar__Webgl.Gl[/* deleteShader */9], context, vertexShader);
      Curry._3(Web_Tar__Webgl.Gl[/* attachShader */8], context, program, fragmentShader);
      Curry._2(Web_Tar__Webgl.Gl[/* deleteShader */9], context, fragmentShader);
      Curry._2(Web_Tar__Webgl.Gl[/* linkProgram */12], context, program);
      var linkedCorrectly = +(Curry._3(Web_Tar__Webgl.Gl[/* getProgramParameter */46], context, program, /* Link_status */1) === 1);
      if (linkedCorrectly) {
        return /* Some */[program];
      }
      else {
        console.log("Linking error: " + Curry._2(Web_Tar__Webgl.Gl[/* getProgramInfoLog */49], context, program));
        return /* None */0;
      }
    }
    else {
      console.log("Fragment shader error: " + Curry._2(Web_Tar__Webgl.Gl[/* getShaderInfoLog */48], context, fragmentShader));
      return /* None */0;
    }
  }
  else {
    console.log("Vertex shader error: " + Curry._2(Web_Tar__Webgl.Gl[/* getShaderInfoLog */48], context, vertexShader));
    return /* None */0;
  }
}

var vertexShaderSource = "\n  attribute vec3 aVertexPosition;\n  attribute vec4 aVertexColor;\n\n  uniform mat4 uPMatrix;\n\n  varying vec4 vColor;\n\n  void main(void) {\n    gl_Position = uPMatrix * vec4(aVertexPosition, 1.0);\n    vColor = aVertexColor;\n  }\n";

var fragmentShaderSource = "\n  varying vec4 vColor;\n\n  void main(void) {\n    gl_FragColor = vColor;\n  }\n";

var $$window = Curry._1(Web_Tar__Webgl.Gl[/* Window */2][/* init */2], Sys.argv);

Curry._3(Web_Tar__Webgl.Gl[/* Window */2][/* setWindowSize */3], $$window, 600, 600);

var context = Curry._1(Web_Tar__Webgl.Gl[/* Window */2][/* getContext */5], $$window);

Curry._5(Web_Tar__Webgl.Gl[/* viewport */38], context, 0, 0, 600, 600);

Curry._2(Web_Tar__Webgl.Gl[/* clear */39], context, Reglinterface__Constants.color_buffer_bit | Reglinterface__Constants.depth_buffer_bit);

var camera = /* record */[/* projectionMatrix */Curry._1(Web_Tar__Webgl.Gl[/* Mat4 */44][/* create */1], /* () */0)];

var vertexBuffer = Curry._1(Web_Tar__Webgl.Gl[/* createBuffer */14], context);

var colorBuffer = Curry._1(Web_Tar__Webgl.Gl[/* createBuffer */14], context);

var match = getProgram(context, vertexShaderSource, fragmentShaderSource);

var program = match ? match[0] : Pervasives.failwith("Could not create the program and/or the shaders. Aborting.");

Curry._2(Web_Tar__Webgl.Gl[/* useProgram */13], context, program);

var aVertexPosition = Curry._3(Web_Tar__Webgl.Gl[/* getAttribLocation */41], context, program, "aVertexPosition");

Curry._2(Web_Tar__Webgl.Gl[/* enableVertexAttribArray */42], context, aVertexPosition);

var aVertexColor = Curry._3(Web_Tar__Webgl.Gl[/* getAttribLocation */41], context, program, "aVertexColor");

Curry._2(Web_Tar__Webgl.Gl[/* enableVertexAttribArray */42], context, aVertexColor);

var pMatrixUniform = Curry._3(Web_Tar__Webgl.Gl[/* getUniformLocation */40], context, program, "uPMatrix");

Curry._3(Web_Tar__Webgl.Gl[/* uniformMatrix4fv */45], context, pMatrixUniform, camera[/* projectionMatrix */0]);

Curry._7(Web_Tar__Webgl.Gl[/* Mat4 */44][/* ortho */6], camera[/* projectionMatrix */0], 0, Curry._1(Web_Tar__Webgl.Gl[/* Window */2][/* getWidth */0], $$window), 0, Curry._1(Web_Tar__Webgl.Gl[/* Window */2][/* getHeight */1], $$window), 0, 100);

function render() {
  var square_vertices = /* float array */[
    450,
    450,
    0.0,
    150,
    450,
    0.0,
    450,
    150,
    0.0,
    150,
    150,
    0.0
  ];
  Curry._3(Web_Tar__Webgl.Gl[/* bindBuffer */15], context, Reglinterface__Constants.array_buffer, vertexBuffer);
  Curry._4(Web_Tar__Webgl.Gl[/* bufferData */37], context, Reglinterface__Constants.array_buffer, Curry._2(Web_Tar__Webgl.Gl[/* Bigarray */36][/* of_array */1], /* Float32 */1, square_vertices), Reglinterface__Constants.static_draw);
  Curry._7(Web_Tar__Webgl.Gl[/* vertexAttribPointer */43], context, aVertexPosition, 3, Reglinterface__Constants.float_, /* false */0, 0, 0);
  var square_colors = /* float array */[
    1,
    0,
    0,
    1,
    1,
    0,
    0,
    1,
    1,
    0,
    0,
    1,
    1,
    0,
    0,
    1
  ];
  Curry._3(Web_Tar__Webgl.Gl[/* bindBuffer */15], context, Reglinterface__Constants.array_buffer, colorBuffer);
  Curry._4(Web_Tar__Webgl.Gl[/* bufferData */37], context, Reglinterface__Constants.array_buffer, Curry._2(Web_Tar__Webgl.Gl[/* Bigarray */36][/* of_array */1], /* Float32 */1, square_colors), Reglinterface__Constants.static_draw);
  Curry._7(Web_Tar__Webgl.Gl[/* vertexAttribPointer */43], context, aVertexColor, 4, Reglinterface__Constants.float_, /* false */0, 0, 0);
  Curry._3(Web_Tar__Webgl.Gl[/* uniformMatrix4fv */45], context, pMatrixUniform, camera[/* projectionMatrix */0]);
  return Curry._4(Web_Tar__Webgl.Gl[/* drawArrays */51], context, Reglinterface__Constants.triangle_strip, 0, 4);
}

Curry.app(Web_Tar__Webgl.Gl[/* render */4], [
      $$window,
      /* None */0,
      /* None */0,
      /* None */0,
      /* None */0,
      /* None */0,
      /* None */0,
      render,
      /* () */0
    ]);

var Constants = 0;

var Gl = 0;

var windowSize = 600;

exports.Constants            = Constants;
exports.Gl                   = Gl;
exports.getProgram           = getProgram;
exports.vertexShaderSource   = vertexShaderSource;
exports.fragmentShaderSource = fragmentShaderSource;
exports.$$window             = $$window;
exports.windowSize           = windowSize;
exports.context              = context;
exports.camera               = camera;
exports.vertexBuffer         = vertexBuffer;
exports.colorBuffer          = colorBuffer;
exports.program              = program;
exports.aVertexPosition      = aVertexPosition;
exports.aVertexColor         = aVertexColor;
exports.pMatrixUniform       = pMatrixUniform;
exports.render               = render;
/* window Not a pure module */
