// Generated by BUCKLESCRIPT VERSION 1.4.3, PLEASE EDIT WITH CARE
'use strict';

var Curry                    = require("bs-platform/lib/js/curry");
var Caml_int32               = require("bs-platform/lib/js/caml_int32");
var Web_Tar__Events          = require("./web_Tar__Events");
var Caml_builtin_exceptions  = require("bs-platform/lib/js/caml_builtin_exceptions");
var Reglinterface__Constants = require("../reglinterface/reglinterface__Constants");

var $$window = (window);

var Document = /* module */[/* window */$$window];

function createCanvas() {
  return document.createElement("canvas");
}

function readFile(filename, cb) {
  var rawFile = new XMLHttpRequest();
  rawFile.open("GET", filename, false);
  rawFile.onreadystatechange = function () {
    if (rawFile.readyState === 4 && (rawFile.status === 200 || rawFile.status === 0)) {
      return Curry._1(cb, rawFile.responseText);
    }
    else {
      return 0;
    }
  };
  return rawFile.send(null);
}

var File = /* module */[/* readFile */readFile];

function getWidth(prim) {
  return prim.width;
}

function getHeight(prim) {
  return prim.height;
}

function init() {
  var canvas = document.createElement("canvas");
  canvas.style.backgroundColor = "black";
  document.body.appendChild(canvas);
  return canvas;
}

function setWindowSize($$window, width, height) {
  $$window.width = width;
  return $$window.height = height;
}

function initDisplayMode(_, _$1, _$2) {
  return /* () */0;
}

function getContext($$window) {
  return $$window.getContext("webgl", {
              preserveDrawingBuffer: /* true */1,
              antialias: /* false */0
            });
}

var Window = /* module */[
  /* getWidth */getWidth,
  /* getHeight */getHeight,
  /* init */init,
  /* setWindowSize */setWindowSize,
  /* initDisplayMode */initDisplayMode,
  /* getContext */getContext
];

function render(canvas, mouseDown, mouseUp, mouseMove, keyDown, keyUp, _, displayFunc, _$1) {
  if (mouseDown) {
    var cb = mouseDown[0];
    canvas.addEventListener("mousedown", function (e) {
          var match = e.button;
          var button;
          if (match > 2 || match < 0) {
            throw [
                  Caml_builtin_exceptions.assert_failure,
                  [
                    "src/webgl.re",
                    154,
                    21
                  ]
                ];
          }
          else {
            switch (match) {
              case 0 : 
                  button = /* LeftButton */0;
                  break;
              case 1 : 
                  button = /* MiddleButton */1;
                  break;
              case 2 : 
                  button = /* RightButton */2;
                  break;
              
            }
          }
          var rect = canvas.getBoundingClientRect();
          var x = e.clientX - rect.left | 0;
          var y = e.clientY - rect.top | 0;
          return Curry._4(cb, button, /* MouseDown */0, x, y);
        });
  }
  if (mouseUp) {
    var cb$1 = mouseUp[0];
    canvas.addEventListener("mouseup", function (e) {
          var match = e.button;
          var button;
          if (match > 2 || match < 0) {
            throw [
                  Caml_builtin_exceptions.assert_failure,
                  [
                    "src/webgl.re",
                    177,
                    21
                  ]
                ];
          }
          else {
            switch (match) {
              case 0 : 
                  button = /* LeftButton */0;
                  break;
              case 1 : 
                  button = /* MiddleButton */1;
                  break;
              case 2 : 
                  button = /* RightButton */2;
                  break;
              
            }
          }
          var rect = canvas.getBoundingClientRect();
          var x = e.clientX - rect.left | 0;
          var y = e.clientY - rect.top | 0;
          return Curry._4(cb$1, button, /* MouseUp */1, x, y);
        });
  }
  if (mouseMove) {
    var cb$2 = mouseMove[0];
    canvas.addEventListener("mousemove", function (e) {
          var rect = canvas.getBoundingClientRect();
          var x = e.clientX - rect.left | 0;
          var y = e.clientY - rect.top | 0;
          return Curry._2(cb$2, x, y);
        });
  }
  var keyLastPressed = [/* None */0];
  if (keyDown) {
    var cb$3 = keyDown[0];
    $$window.addEventListener("keydown", function (e) {
          var keycode = e.which;
          var match = keyLastPressed[0];
          var repeat = match ? +(match[0] === keycode) : /* false */0;
          keyLastPressed[0] = /* Some */[keycode];
          return Curry._2(cb$3, Web_Tar__Events.keycodeMap(keycode), repeat);
        });
  }
  if (keyUp) {
    var cb$4 = keyUp[0];
    $$window.addEventListener("keyup", function (e) {
          var keycode = e.which;
          keyLastPressed[0] = /* None */0;
          return Curry._1(cb$4, Web_Tar__Events.keycodeMap(keycode));
        });
  }
  var tick = function (prev, _) {
    var now = Date.now();
    Curry._1(displayFunc, now - prev);
    window.requestAnimationFrame(function (param) {
          return tick(now, param);
        });
    return /* () */0;
  };
  var partial_arg = Date.now();
  window.requestAnimationFrame(function (param) {
        return tick(partial_arg, param);
      });
  return /* () */0;
}

function shaderSource(context, shader, source) {
  return context.shaderSource(shader, "#version 100 \n precision highp float; \n" + source);
}

function toTextureData(data) {
  return new Uint8Array(data);
}

function bindFrameBuffer(context, target, frameBuffer) {
  if (frameBuffer) {
    return context.bindFramebuffer(target, frameBuffer[0]);
  }
  else {
    return context.bindFramebuffer(target, null);
  }
}

function readPixelsRGBA(context, x, y, width, height) {
  var data = new Uint8Array((Caml_int32.imul(width, height) << 2));
  context.readPixels(x, y, width, height, Reglinterface__Constants.rgba, Reglinterface__Constants.unsigned_byte, data);
  return data;
}

function loadImage(filename, _, callback, _$1) {
  var image = new Image();
  image.src = filename;
  return image.addEventListener("load", function () {
              return Curry._1(callback, /* Some */[image]);
            });
}

function texImage2DWithImage(context, target, level, image) {
  return context.texImage2D(target, level, Reglinterface__Constants.rgba, Reglinterface__Constants.rgba, Reglinterface__Constants.unsigned_byte, image);
}

function texImage2D(context, target, level, internalFormat, width, height, format, type_, data) {
  return context.texImage2D(target, level, internalFormat, width, height, 0, format, type_, data);
}

function create(kind, size) {
  switch (kind) {
    case 0 : 
        return new Float64Array(size);
    case 1 : 
        return new Float32Array(size);
    case 2 : 
        return new Int16Array(size);
    case 3 : 
        return new Uint16Array(size);
    case 4 : 
        return new Int8Array(size);
    case 5 : 
    case 6 : 
        return new Uint8Array(size);
    case 8 : 
        throw [
              Caml_builtin_exceptions.assert_failure,
              [
                "src/webgl.re",
                476,
                17
              ]
            ];
    case 7 : 
    case 9 : 
        return new Int32Array(size);
    
  }
}

function of_array(kind, arr) {
  switch (kind) {
    case 0 : 
        return new Float64Array(arr);
    case 1 : 
        return new Float32Array(arr);
    case 2 : 
        return new Int16Array(arr);
    case 3 : 
        return new Uint16Array(arr);
    case 4 : 
        return new Int8Array(arr);
    case 5 : 
    case 6 : 
        return new Uint8Array(arr);
    case 8 : 
        throw [
              Caml_builtin_exceptions.assert_failure,
              [
                "src/webgl.re",
                489,
                17
              ]
            ];
    case 7 : 
    case 9 : 
        return new Int32Array(arr);
    
  }
}

function sub(arr, offset, len) {
  return arr.subarray(offset, offset + len | 0);
}

function vertexAttribPointer(context, attribute, size, type_, normalize, stride, offset) {
  var normalize$1 = normalize ? true : false;
  return context.vertexAttribPointer(attribute, size, type_, normalize$1, stride, offset);
}

function to_array(a) {
  return a;
}

function Mat4_001() {
  return mat4.create();
}

function Mat4_002(prim) {
  mat4.identity(prim);
  return /* () */0;
}

function Mat4_003(prim, prim$1, prim$2) {
  mat4.translate(prim, prim$1, prim$2);
  return /* () */0;
}

function Mat4_004(prim, prim$1, prim$2) {
  mat4.scale(prim, prim$1, prim$2);
  return /* () */0;
}

function Mat4_005(prim, prim$1, prim$2, prim$3) {
  mat4.rotate(prim, prim$1, prim$2, prim$3);
  return /* () */0;
}

function Mat4_006(prim, prim$1, prim$2, prim$3, prim$4, prim$5, prim$6) {
  mat4.ortho(prim, prim$1, prim$2, prim$3, prim$4, prim$5, prim$6);
  return /* () */0;
}

var Mat4 = /* module */[
  /* to_array */to_array,
  Mat4_001,
  Mat4_002,
  Mat4_003,
  Mat4_004,
  Mat4_005,
  Mat4_006
];

function uniformMatrix4fv(context, $$location, value) {
  return context.uniformMatrix4fv($$location, false, value);
}

function getProgramParameter(context, program, paramName) {
  switch (paramName) {
    case 0 : 
        if (context.getProgramParameter(program, context.DELETE_STATUS)) {
          return 1;
        }
        else {
          return 0;
        }
    case 1 : 
        if (context.getProgramParameter(program, context.LINK_STATUS)) {
          return 1;
        }
        else {
          return 0;
        }
    case 2 : 
        if (context.getProgramParameter(program, context.VALIDATE_STATUS)) {
          return 1;
        }
        else {
          return 0;
        }
    
  }
}

function getShaderParameter(context, shader, paramName) {
  switch (paramName) {
    case 0 : 
        if (context.getShaderParameter(shader, context.DELETE_STATUS)) {
          return 1;
        }
        else {
          return 0;
        }
    case 1 : 
        if (context.getShaderParameter(shader, context.COMPILE_STATUS)) {
          return 1;
        }
        else {
          return 0;
        }
    case 2 : 
        return context.getShaderParameter(shader, context.SHADER_TYPE);
    
  }
}

var Gl_003 = /* Events : Web_Tar__Events */[Web_Tar__Events.keycodeMap];

function Gl_005(prim, prim$1, prim$2, prim$3, prim$4) {
  return prim.clearColor(prim$1, prim$2, prim$3, prim$4);
}

function Gl_006(prim) {
  return prim.createProgram();
}

function Gl_007(prim, prim$1) {
  return prim.createShader(prim$1);
}

function Gl_008(prim, prim$1, prim$2) {
  return prim.attachShader(prim$1, prim$2);
}

function Gl_009(prim, prim$1) {
  return prim.deleteShader(prim$1);
}

function Gl_011(prim, prim$1) {
  return prim.compileShader(prim$1);
}

function Gl_012(prim, prim$1) {
  return prim.linkProgram(prim$1);
}

function Gl_013(prim, prim$1) {
  return prim.useProgram(prim$1);
}

function Gl_014(prim) {
  return prim.createBuffer();
}

function Gl_015(prim, prim$1, prim$2) {
  return prim.bindBuffer(prim$1, prim$2);
}

function Gl_016(prim) {
  return prim.createTexture();
}

function Gl_017(prim, prim$1) {
  return prim.activeTexture(prim$1);
}

function Gl_018(prim, prim$1, prim$2) {
  return prim.bindTexture(prim$1, prim$2);
}

function Gl_019(prim, prim$1, prim$2, prim$3) {
  return prim.texParameteri(prim$1, prim$2, prim$3);
}

function Gl_021(prim, prim$1) {
  return prim.enable(prim$1);
}

function Gl_022(prim, prim$1) {
  return prim.disable(prim$1);
}

function Gl_023(prim, prim$1, prim$2) {
  return prim.blendFunc(prim$1, prim$2);
}

function Gl_024(prim) {
  return prim.createFramebuffer();
}

function Gl_026(prim, prim$1, prim$2, prim$3, prim$4, prim$5) {
  return prim.framebufferTexture2D(prim$1, prim$2, prim$3, prim$4, prim$5);
}

function Gl_028(prim) {
  return prim.width;
}

function Gl_029(prim) {
  return prim.height;
}

function Gl_033(prim, prim$1, prim$2) {
  return prim.uniform1i(prim$1, prim$2);
}

function Gl_034(prim, prim$1, prim$2) {
  return prim.uniform1f(prim$1, prim$2);
}

function Gl_035(prim, prim$1) {
  return prim.generateMipmap(prim$1);
}

var Gl_036 = /* Bigarray */[
  create,
  of_array,
  function (prim) {
    return prim.length;
  },
  function (prim, prim$1) {
    return prim[prim$1];
  },
  function (prim, prim$1, prim$2) {
    return prim[prim$1] = prim$2;
  },
  sub
];

function Gl_037(prim, prim$1, prim$2, prim$3) {
  return prim.bufferData(prim$1, prim$2, prim$3);
}

function Gl_038(prim, prim$1, prim$2, prim$3, prim$4) {
  return prim.viewport(prim$1, prim$2, prim$3, prim$4);
}

function Gl_039(prim, prim$1) {
  return prim.clear(prim$1);
}

function Gl_040(prim, prim$1, prim$2) {
  return prim.getUniformLocation(prim$1, prim$2);
}

function Gl_041(prim, prim$1, prim$2) {
  return prim.getAttribLocation(prim$1, prim$2);
}

function Gl_042(prim, prim$1) {
  return prim.enableVertexAttribArray(prim$1);
}

function Gl_048(prim, prim$1) {
  return prim.getShaderInfoLog(prim$1);
}

function Gl_049(prim, prim$1) {
  return prim.getProgramInfoLog(prim$1);
}

function Gl_050(prim, prim$1) {
  return prim.getShaderSource(prim$1);
}

function Gl_051(prim, prim$1, prim$2, prim$3) {
  return prim.drawArrays(prim$1, prim$2, prim$3);
}

function Gl_052(prim, prim$1, prim$2, prim$3, prim$4) {
  return prim.drawElements(prim$1, prim$2, prim$3, prim$4);
}

var Gl = /* module */[
  /* target */"web",
  /* File */File,
  /* Window */Window,
  Gl_003,
  /* render */render,
  Gl_005,
  Gl_006,
  Gl_007,
  Gl_008,
  Gl_009,
  /* shaderSource */shaderSource,
  Gl_011,
  Gl_012,
  Gl_013,
  Gl_014,
  Gl_015,
  Gl_016,
  Gl_017,
  Gl_018,
  Gl_019,
  /* toTextureData */toTextureData,
  Gl_021,
  Gl_022,
  Gl_023,
  Gl_024,
  /* bindFrameBuffer */bindFrameBuffer,
  Gl_026,
  /* readPixelsRGBA */readPixelsRGBA,
  Gl_028,
  Gl_029,
  /* loadImage */loadImage,
  /* texImage2DWithImage */texImage2DWithImage,
  /* texImage2D */texImage2D,
  Gl_033,
  Gl_034,
  Gl_035,
  Gl_036,
  Gl_037,
  Gl_038,
  Gl_039,
  Gl_040,
  Gl_041,
  Gl_042,
  /* vertexAttribPointer */vertexAttribPointer,
  /* Mat4 */Mat4,
  /* uniformMatrix4fv */uniformMatrix4fv,
  /* getProgramParameter */getProgramParameter,
  /* getShaderParameter */getShaderParameter,
  Gl_048,
  Gl_049,
  Gl_050,
  Gl_051,
  Gl_052
];

exports.Document     = Document;
exports.createCanvas = createCanvas;
exports.Gl           = Gl;
/* window Not a pure module */
